#include "tlang.h"

tobject_t* _node_setvariable_exec(node_t* n,scope_t* sc,retarg_t* retArg)
{
    node_t* left=n->data.variable_set_node.variable;
    node_t* right = n->data.variable_set_node.value;
    tobject_t* o = right->execute(right,sc,retArg);
    o->count++;
    if(left->type == getarraynode)
    {
        
        left->data.array_node.set(left,o,sc);
    }
    if(left->type == getvariablenode || left->type == getmembernode)
    {
        left->data.variable_node.set(left,o,sc);
    }
    o->count--;
    return o;
}
void __setVar_free(node_t* n)
{
    if(n->data.variable_set_node.deleteVariableNode)
        node_free(n->data.variable_set_node.variable);
    node_free(n->data.variable_set_node.value);
}
node_t* node_setvariable_create(node_t* n1,node_t* n2,bool delVar)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = setvariablenode;
    n->data.variable_set_node.variable = n1;
    n->data.variable_set_node.value = n2;
    n->data.variable_set_node.deleteVariableNode = delVar;
    n->execute = _node_setvariable_exec;
    n->free = __setVar_free;
    return n;
}
