#include "tlang.h"
extern void __node_two_free(node_t* n);
 extern void __node_single_free(node_t* n);
tobject_t* __case_node_exec(node_t* n,scope_t* s,retarg_t* retArg)
{
    return n->data.two_node_node.right->execute(n->data.two_node_node.right,s,retArg);
}
tobject_t* __default_node_exec(node_t* n,scope_t* s,retarg_t* retArg)
{
    return n->data.single_node_node->execute(n->data.single_node_node,s,retArg);
}
node_t* node_case_create(node_t* left,node_t* right)
{
    node_t* node = (node_t*)malloc(sizeof(node_t));
    node->type = casenode;
    node->data.two_node_node.left = left;
    node->data.two_node_node.right = right;
    node->execute = __case_node_exec;
    node->free = __node_two_free;
    return node;
}

node_t* node_default_create(node_t* body)
{
    node_t* node = (node_t*)malloc(sizeof(node_t));
    node->type = defaultnode;
    node->data.single_node_node = body;
    node->execute = __default_node_exec;
    node->free = __node_single_free;
    return node;
}