#include "tlang.h"

tobject_t* __closure_node_exec(node_t* n,scope_t* sc,retarg_t* retArg)
{
    tobject_t* c = tobject_create(sc->rt);
    c->type = tinternalmethod;
    c->data.internal_method.closure = node_closure_create(n->data.closure_node.argNames,n->data.closure_node.node);
    c->data.internal_method.scope = sc;
    sc->count++;
    return c;
}
void __closure_free(node_t* n)
{
    
}

node_t* node_closure_create(list_string_t argNames,node_t* right)
{
    node_t* node = (node_t*)malloc(sizeof(node_t));
    node->type = addnode;
    node->data.closure_node.argNames = argNames;
    node->data.closure_node.node = right;
    node->execute = __closure_node_exec;
    node->free = __closure_free;
    return node;
}