#include "tlang.h"
tobject_t* __each_loop_exec(node_t* n,scope_t* s,retarg_t* retArg)
{
    tobject_t* ls=NULL;
    s=scope_begin(s);
    if(n->data.eachloop_node.ls != NULL)
    ls= n->data.eachloop_node.ls->execute(n->data.eachloop_node.ls,s,retArg);
    
    tobject_t* res = tobject_basic(s->rt,tundef);
    res->count=1;
    retArg->isBreaking=false;
    retArg->isContinue=false;
    if(ls != NULL)
    {
        ittr_t* ittr = ittr_obj(ls,s);
        if(ittr != NULL)
        {
            while(ittr_movenext(ittr) && !retArg->isBreaking && !retArg->isReturning)
            {
               tobject_t* obj= ittr->getcurrent(ittr);
               if(n->data.eachloop_node.variable->type == getvariablenode || n->data.eachloop_node.variable->type == getmembernode)
               {
                    n->data.eachloop_node.variable->data.variable_node.set(n->data.eachloop_node.variable,obj,s);
               }else
               if(n->data.eachloop_node.variable->type == getarraynode)
               {
                    n->data.eachloop_node.variable->data.array_node.set(n->data.eachloop_node.variable,obj,s);
               }
               tobject_t* myRes=n->data.eachloop_node.body->execute(n->data.eachloop_node.body,s,retArg);
               retArg->isContinue=false;
               tobject_addref(myRes);
               tobject_rmref(res);
               
               res=myRes;
               tobject_freeifzero(obj);
            }
            ittr_free(ittr);
        }
    }
    retArg->isBreaking=false;
    retArg->isContinue=false;
    s=scope_end(s);
    tobject_freeifzero(ls);
    res->count--;
    return res;
}
void __each_loop_free(node_t* n)
{
    if(n->data.eachloop_node.variable != NULL)
    node_free(n->data.eachloop_node.variable);
    if(n->data.eachloop_node.ls != NULL)
    node_free(n->data.eachloop_node.ls);
    if(n->data.eachloop_node.body != NULL)
    node_free(n->data.eachloop_node.body);
}
node_t* node_eachloop_create(node_t* var,node_t* ls,node_t* body)
{
    node_t* node = (node_t*)malloc(sizeof(node_t));
    node->type = eachloopnode;
    node->data.eachloop_node.variable = var;
    node->data.eachloop_node.ls = ls;
    
    node->data.eachloop_node.body = body;
    node->execute = __each_loop_exec;
    node->free = __each_loop_free;
    return node;
}