#include "tlang.h"
#include "tlang.h"

extern void __node_two_free(node_t* n);
tobject_t* __eq_node_exec(node_t* n,scope_t* sc,retarg_t* retArg)
{
    bool freeleftifzero=true;
    
    node_t* left = n->data.two_node_node.left;
    node_t* right = n->data.two_node_node.right;
    tobject_t* l=left->execute(left,sc,retArg);
    tobject_t* r=right->execute(right,sc,retArg);
    tobject_t* out=tobject_same(sc->rt,l,r,&freeleftifzero);
    if(out != NULL) out->count++;
    if(freeleftifzero)
    {
       
        tobject_freeifzero(l);
        
    }
   
        tobject_freeifzero(r);
    if(out != NULL) out->count--;
    if(out == NULL)
    {
        return tobject_basic(sc->rt,tnull);
    }
    return out;
}
node_t* node_eq_create(node_t* left,node_t* right)
{
    node_t* node = (node_t*)malloc(sizeof(node_t));
    node->type = equalsnode;
    node->data.two_node_node.left = left;
    node->data.two_node_node.right = right;
    node->execute = __eq_node_exec;
    node->free = __node_two_free;
    return node;
}