#include "tlang.h"
#include <stdlib.h>
#include <stdint.h>

tobject_t* rand_getnext_external_function(runtime_t* rt,void* ptr,list_tobject_t* args)
{
if(args->length >= 0)
{
double _res = (double)rand();
return tobject_number(rt,_res);
}
return tobject_basic(rt,tnull);
}
tobject_t* rand_setseed_external_function(runtime_t* rt,void* ptr,list_tobject_t* args)
{
if(args->length >= 1 && (args->items[0]->type == tnumber || args->items[0]->type == tnull))
{
int _arg0 = (int)args->items[0]->data.number;
srand(_arg0);


}
return tobject_basic(rt,tnull);
}

void runtime_register_rand(runtime_t* rt)
{
tobject_t* _rand = tobject_create(rt);
_rand->type = tdict;
_rand->data.dict = dict_create();
runtime_create_method_on_dict(_rand->data.dict,"getnext",rt,NULL,rand_getnext_external_function,NULL);
runtime_create_method_on_dict(_rand->data.dict,"setseed",rt,NULL,rand_setseed_external_function,NULL);

rt->globals->setvariable(rt->globals,"rand",_rand);
}
